#ifndef _CONFIG_H
#define _CONFIG_H
@TOP@
/* Process this file with autoheader to produce a config.h.in */

/* Define if you have snprintf */
#undef HAVE_SNPRINTF

/* Define if you have a snprintf ignoring n */
#undef HAVE_SNPRINTF_OFLOW

/* Define if you have a snprintf not terminating strings */
#undef HAVE_SNPRINTF_NOTTERMINATED

/* Define if you have a strncpy not terminating strings */
#undef HAVE_STRNCPY_NOTTERMINATED

/* Define if you have a strncat not terminating strings */
#undef HAVE_STRNCAT_NOTTERMINATED

/* Define if you have a working fork */
#undef HAVE_NO_FORK

/* Type of second argument of accept */
#undef ACCEPT_ARG2

/* Type of third argument of accept */
#undef ACCEPT_ARG3

/* Type of third argument of setsockopt */
#undef SETSOCKOPT_ARG4

/* Type of socklen_t */
#undef socklen_t

/* Type of rlim_t */
#undef rlim_t

/* Define to use exec to delete HTTP_AUTHORIZATION */
#undef CONF_AUTH_EXEC

/* Define to use file descriptor only method */
#undef CONF_AUTH_EXEC_FD

/* Define this to remove unknown environment variables */
#undef CONF_PARANOID_ENV

/* Define to default umask */
#undef CONF_UMASK

/* Define httpd user, undef to disable check */
#undef CONF_HTTPD_USER

/* Define this to enable suEXEC compatibility mode */
#undef CONF_SUEXEC

/* Define this to enable wrapper checks to see if it is setuid */
#undef CONF_CHECK_SETUID

/* Define this to redirect stderr to stdout */
#undef CONF_REDIR_STDERR

/* Define this to enable logging to syslog */
#undef CONF_USE_SYSLOG

/* Define this to enable logging to a file */
#undef CONF_MODIWRAP_LOG

/* Define this to check log file properties */
#undef CONF_CHECK_LOG

/* Define maximum loginfo size (minimum=1) */
#undef CONF_MAXLOGINFO

/* Define wrapper config file */
#undef CONF_MODIWRAP_CONFIG

/* Define minimum script search depth in substandstat */
#undef CONF_MIN_DEPTH

/* Define maximum script search depth in substandstat */
#undef CONF_MAX_DEPTH

/* Define this if you want to check for non-printable chars in pathnames */
#undef CONF_CHECK_PRINTABLE

/* Define this if you want to check for '//' in pathnames */
#undef CONF_CHECK_DOUBLESLASH

/* Define this if wrapper should block scripts readable by group/others */
#undef CONF_CHECK_SCRIPT_READ

/* Define this if wrapper should block scripts writable by group/others */
#undef CONF_CHECK_SCRIPT_WRITE

/* Define this if wrapper should block scripts executable by group/others */
#undef CONF_CHECK_SCRIPT_EXEC

/* Define this if wrapper should block scripts run by uid not file owner */
#undef CONF_CHECK_SCRIPT_UID

/* Define this if wrapper should block scripts run by gid not file group */
#undef CONF_CHECK_SCRIPT_GID

/* Define this if wrapper should check script dirs */
#undef CONF_CHECK_DIR

/* Define this if wrapper should check only 1 level of script dirs */
#undef CONF_CHECK_DIR_1

/* Define this if wrapper should check if dirs are writable by group/others */
#undef CONF_CHECK_DIR_WRITE

/* Define this if wrapper should check dirs uid */
#undef CONF_CHECK_DIR_UID

/* Define this if wrapper should check dirs gid */
#undef CONF_CHECK_DIR_GID

/* Define max path len */
#undef CONF_MAXPATHLEN

/* Forward signals to scripts */
#undef CONF_FORWARD_SIGNALS

/* Define this if you want to use limits */
#undef CONF_USE_LIMITS

/* Nice default limit, see man setpriority/man nice */
#undef CONF_NICE

/* Elapsed time limit (real world time, vs cpu time) */
#undef CONF_TIMEALRM

/* rlimits, see man setrlimit to see effects on your system */
#undef CONF_RLIMIT_CPU
#undef CONF_RLIMIT_VMEM
#undef CONF_RLIMIT_FSIZE
#undef CONF_RLIMIT_DATA
#undef CONF_RLIMIT_STACK
#undef CONF_RLIMIT_AS
#undef CONF_RLIMIT_CORE
#undef CONF_RLIMIT_RSS
#undef CONF_RLIMIT_NPROC
#undef CONF_RLIMIT_NOFILE
#undef CONF_RLIMIT_MEMLOCK
#undef CONF_RLIMIT_LOCKS

/* Define this to use a limits daemon */
#undef CONF_USE_LIMITS_DAEMON

/* Define this to use gethostbyname (if you don't use a IP) */
#undef CONF_USE_GETHOSTBYNAME

/* Define this to use a daemon timeout */
#undef CONF_LIMITS_DAEMON_TIMEOUT

/* Define daemon address */
#undef CONF_LIMITS_DAEMON_ADDR

/* Define daemon port */
#undef CONF_LIMITS_DAEMON_PORT

/* Define socket buffer size */
#undef CONF_SOCKBUFSIZE

/* Define this to use setgroups */
#undef CONF_USE_SETGROUPS

/* Define this to use initgroups */
#undef CONF_USE_INITGROUPS

/* Define this to use AFS setpag() */
#undef CONF_USE_AFS_SETPAG

/* Define minimum uid wrapper can change to */
#undef CONF_MINIMUM_UID

/* Define minimum uid wrapper can change to */
#undef CONF_MINIMUM_GID

/* Define this if you want to check user shell */
#undef CONF_CHECK_SHELL

/* Define authorized shells list file */
#undef CONF_SHELLS

/* Define maximum shell size */
#undef CONF_MAXSHELLSIZE

/* Define script paths/filenames allowed */
#undef CONF_SCRIPT_DOMAIN

/* Define this to parse .htaccess (apache must be compiled with SECURITY_HOLE_PASS_AUTHORIZATION) */
#undef CONF_USE_HTACCESS

/* Define this to enforce DOCUMENT_ROOT in user supplied pathnames in .htaccess */
#undef CONF_ENFORCE_DOCUMENT_ROOT

/* Define this if !ENFORCE_DOCUMENT_ROOT and want forbid /etc in user supplied pathnames in .htaccess */
#undef CONF_ENFORCE_NOT_ETC

/* Define max htpasswd line size */
#undef CONF_MAXUSERSIZE

/* Define max htgroup line size */
#undef CONF_MAXGROUPSIZE

/* Define this to use ErrorDocument */
#undef CONF_USE_ERRORDOCUMENT

/* Define max local vars */
#undef CONF_MAXLOCALVARS

/* Define max num of regex matches */
#undef CONF_MAXREGMATCH

/* Define max string size */
#undef MAXSTRINGSIZE

/* Define this to free flex buffers */
#undef CONF_YYCLEAN

/* Daemon limits file */
#undef CONF_MODIWRAPD_LIMITS

/* Daemon request timeout */
#undef CONF_MODIWRAPD_REQUEST_TIMEOUT

/* Delay between limits file checks */
#undef CONF_MODIWRAPD_FORCE_CHECK_CONF_DELAY

/* Bind to any instead of DAMEON_ADDR */
#undef CONF_MODIWRAPD_BIND_ANY

/* Daemon accept netaddr */
#undef CONF_MODIWRAPD_ACCEPT_NETADDR

/* Daemon accept netmask */
#undef CONF_MODIWRAPD_ACCEPT_NETMASK

@BOTTOM@

#ifndef HAVE_STRCASECMP
#define strcasecmp(a,b) stricmp(a,b)
#endif

#ifdef MEMWATCH
#ifdef HAVE_STRING_H
#include<string.h>
#endif
#include"memwatch.h"
#endif
#endif
