#include"func.h"

/* string must begin with " and end with " or \r or \n !!! */
char *extractstring(char *string)
{
  char *res;
  char *resptr;
  char *ptr;

  if(string == NULL)
  {
    return (NULL);
  }

  res = (char *)malloc(strlen(string) * sizeof(char));

  if(res == NULL)
  {
    return (NULL);
  }

  ptr = string + 1;		/* skip beginning " */
  resptr = res;
  while(*ptr != '\0')
  {
    if(*ptr == '\\' && *(ptr + 1) == '"')
    {
      ptr++;
    }
    else if(*(ptr + 1) != '\0'
	    && (*ptr == '\\' && *(ptr + 1) == '\\' && *(ptr + 2) == '"'))
    {
      ptr++;
    }

    *resptr = *ptr;
    ptr++;
    resptr++;
  }
  resptr--;			/* skip last char ("|\r|\n) */
  *resptr = '\0';

  return (res);
}

int safeatoi(const char *nptr)
{
  if(nptr == NULL)
  {
    return (0);
  }
  else
  {
    return (atoi(nptr));
  }
}

int home(const char *username, const char *savedusername,
	 const char *savedhome, char *dest, size_t destsize)
{
  struct passwd *tmp;

  if(dest == NULL || destsize < 1)
  {
    return (-1);
  }

  dest[0] = '\0';

  if(username == NULL)
  {
    return (-1);
  }

  if(savedusername != NULL && !strcmp(username, savedusername))
  {
    strncpy(dest, savedhome, destsize - 1);
#ifdef HAVE_STRNCPY_NOTTERMINATED
    dest[destsize - 1] = '\0';
#endif
    return (0);
  }

  tmp = getpwnam(username);
  if(tmp == NULL)
  {
    return (-1);
  }
  else
  {
    strncpy(dest, tmp->pw_dir, destsize - 1);
#ifdef HAVE_STRNCPY_NOTTERMINATED
    dest[destsize - 1] = '\0';
#endif
    return (0);
  }
}

int concat(const char *str1, const char *str2, char *dest, size_t destsize)
{
  if(dest == NULL || destsize < 1)
  {
    return (-1);
  }

  dest[0] = '\0';
  if(str1 != NULL)
  {
    strncat(dest, str1, destsize - strlen(dest) - 1);
#ifdef HAVE_STRNCAT_NOTTERMINATED
    dest[destsize - 1] = '\0';
#endif
  }
  if(str2 != NULL)
  {
    strncat(dest, str2, destsize - strlen(dest) - 1);
#ifdef HAVE_STRNCAT_NOTTERMINATED
    dest[destsize - 1] = '\0';
#endif
  }

  return (0);
}

int concatnotnull(const char *str1, const char *str2, char *dest,
		  size_t destsize)
{
  if(str1 == NULL || str2 == NULL)
  {
    if(dest != NULL && destsize > 0)
    {
      dest[0] = '\0';
    }
    return (-1);
  }
  else
  {
    return (concat(str1, str2, dest, destsize));
  }
}
