#ifndef _OUTPUT_H
#define _OUTPUT_H

#ifdef HAVE_CONFIG_H
#include"config.h"
#endif

#ifdef HAVE_STDIO_H
#include<stdio.h>
#endif

#ifdef HAVE_ERRNO_H
#include<errno.h>
#endif

#ifdef HAVE_STRING_H
#include<string.h>
#endif

#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif

#if defined(HAVE_SYSLOG_H) && defined(HAVE_SYSLOG) && defined(CONF_USE_SYSLOG)
#include<syslog.h>
#endif

#ifdef CONF_MODIWRAP_LOG
#ifdef HAVE_UNISTD_H
#include<unistd.h>
#endif

#ifdef HAVE_SYS_TYPES_H
#include<sys/types.h>
#endif

#ifdef HAVE_SYS_STAT_H
#include<sys/stat.h>
#endif

#ifdef HAVE_FCNTL_H
#define __USE_GNU
#include<fcntl.h>
#endif

/* temp fix */
#ifndef O_NOFOLLOW
#define O_NOFOLLOW 0400000
#endif

/* correct equiv for SETFD */
#ifndef FD_CLOEXEC
#define FD_CLOEXEC 1

#endif

#endif

#include"var.h"

int initlog(void);
void closelog(void);

#ifdef CONF_USE_ERRORDOCUMENT
void registererrorpage(int error, char *path);
#endif

void wrapredirect(const char *url);

#ifdef CONF_USE_ERRORDOCUMENT
int wraperrordocument(int status, char *neededheaders);
#endif

void wrapnotfound(void);
void wraperror(const char *subject, const char *detail);
void wraperrorlog(const char *subject, const char *detail);
void wrapwarning(const char *subject, const char *detail);
void wrapinfo(const char *subject, const char *detail);
void wrapaskforauth(const char *authtype, const char *authname);

#endif
