#include"signals.h"

extern int childpid;

#if defined(CONF_FORWARD_SIGNALS) || defined(CONF_TIMEALRM)
RETSIGTYPE wrappersignals(int signum)
{
#if defined(CONF_TIMEALRM) && defined(SIGCHLD)
  int alrm;
#endif

  if(childpid > 0)
  {
#if defined(CONF_TIMEALRM) && defined(SIGCHLD)
    alrm = alarm(0);
    if(signum == SIGCHLD && alrm == 0)	/* TIMEALRM */
    {
      killpg(childpid, SIGKILL);
      kill(childpid, SIGKILL);	/* just in case :) */
      return;
    }
    else
    {
      alarm(alrm);
    }
#endif

#ifdef CONF_FORWARD_SIGNALS
    kill(childpid, signum);
#endif
  }
}
#endif

#ifdef CONF_FORWARD_SIGNALS
void setwrappersignals(void)
{
  int i;

  for(i = 0; i < _NSIG; i++)
  {
#ifdef CONF_TIMEARLM
    if(i != SIGALRM)		/* see rlimitsansalarm */
    {
#endif
      signal(i, wrappersignals);
#ifdef CONF_TIMEARLM
    }
#endif
  }
}
#endif

#ifdef CONF_FORWARD_SIGNALS
void setdefaultwrappersignals(void)
{
  int i;

  for(i = 0; i < _NSIG; i++)
  {
    signal(i, SIG_DFL);
  }
}
#endif
